﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace Narfi
{
    class SelectFields
    {
        const bool NO_APPENDING = false;
        const int ERROR_CODE = 1;

        bool removeSeparators;
        char separator;
        Encoding encoded;
        int fieldCount;
        string bits, fileName;

        public int reading(string newName)
        {
            Dividing d;
            int exit_code = 0;
            string line;

            try
            {
                StreamWriter newFile = new StreamWriter(newName, NO_APPENDING, encoded);
                StreamReader sjisFile = new StreamReader(fileName, encoded);

                for (; ; )
                {
                    line = sjisFile.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    d = new Dividing(line, bits, fieldCount, separator, removeSeparators);
                    newFile.WriteLine( d.unite() );
                } //for (; ; )

                newFile.Close();
                sjisFile.Close();
            }
            catch (IOException e43)
            {
                Console.Error.WriteLine(fileName);
                Error.handler(e43.ToString());
                exit_code = ERROR_CODE;
            }

            return exit_code;
        }

        public SelectFields(Encoding e, string f, string b, int t, char s, bool r)
        {
            bits = b;
            encoded = e;
            fileName = f;
            fieldCount = t;
            removeSeparators = r;
            separator = s;
        }

    }
}
