﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace Narfi
{
    class Standard_input
    {
        const bool NO_APPENDING = false;
        const int ERROR_CODE = 1;

        bool removeSeparators;
        char separator;
        int fieldCount;
        string bits;

        public int standard_input_output()
        {
            Dividing d;
            int exit_code = 0;
            string line;

            try
            {
                for (; ; )
                {
                    line = Console.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    d = new Dividing(line, bits, fieldCount, separator, removeSeparators);
                    Console.WriteLine( d.unite() );
                } //for (; ; )

            }
            catch (IOException e44)
            {
                Error.handler(e44.ToString());
                exit_code = ERROR_CODE;
            }

            return exit_code;
        }

        public Standard_input(string b, int f, char s, bool r)
        {
            bits = b;
            fieldCount = f;
            removeSeparators = r;
            separator = s;
        }

    }
}
