﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace Obot
{
    class Represented_in_hexadecimal
    {
        const int COLUMN_COUNT = 20;
        const int ERROR_CODE = 1;
        const int FIELD_SIZE = 3;
        const string EMPTY = "";

        byte[] buffer;
        int bufferSize, limit, lineCount, size;
        string fileName;

        public int run()
        {
            byte c;
            int exit_code = 0;
            int k = 0;

            try
            {
                Stream binaryFile = File.OpenRead(fileName);
                size = binaryFile.Read(buffer, 0, bufferSize);

                while (k < size)
                {
                    for (int i = 0; i < COLUMN_COUNT; ++i)
                    {
                        c = buffer[k++];
                        Console.Write(string.Format("{0:X2} ", c));

                        if (c == 0x0A)
                        {
                            lineCount += 1;
                            if (lineCount >= limit)
                            {
                                k = size;
                            }

                        }

                        if (k >= size)
                        {
                            break;
                        }

                    }

                    Console.WriteLine(EMPTY);
                }

                binaryFile.Close();
            }
            catch (IOException e47)
            {
                Console.Error.WriteLine(fileName);
                Error.handler(e47.ToString());
                exit_code = ERROR_CODE;
            }

            return exit_code;
        }

        public Represented_in_hexadecimal(string f, int b, int l)
        {
            fileName = f;
            limit = l;
            bufferSize = b;
            buffer = new byte[bufferSize];
        }

    }
}
