﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Atnd
{
    class Guide
    {
        const int ERROR_CODE = 1;
        const string EMPTY = "";

        public int versionGuide(double versionNumber, bool comments)
        {
            Console.Write("Atnd C# Version ");
            Console.WriteLine(versionNumber);
            Console.WriteLine(EMPTY);

            if (comments)
            {
                Console.WriteLine("Atnd -a2 -p567 file        # 2 lines after line-567 ");
                Console.WriteLine("Atnd -b3 -p567 file        # 3 lines before line-567 ");
                Console.WriteLine("Atnd -c4 -p567 file        # 4 lines before line-567 and 4 lines after line-567");
                Console.WriteLine("Atnd -h8 file              # Line-1, Line-2, Line-3, ..., Line-8 ");
                Console.WriteLine("Atnd -h8 < file            # Line-1, Line-2, Line-3, ..., Line-8 ");
                Console.WriteLine("Atnd -i90-123 file         # Line-90, Line-91, Line-92, ..., Line-123 ");
                Console.WriteLine("Atnd -LF -p567 file        # Count lines. Record the max span from LF to LF. ");
                Console.WriteLine("Atnd -LF -p567 -s, file    # Record the max span from separator to separator. ");
                Console.WriteLine("Atnd -LF -p567 -s\\x2C file # Record the max span from separator to separator. ");
                Console.WriteLine("Atnd -p567 file            # line-567 ");
                Console.WriteLine("Atnd -V                    # version ");
                Console.WriteLine("Atnd -VC                   # version with comments ");
                Console.WriteLine("Atnd file -t9              # 9 lines before EOF ");
                Console.WriteLine("DIR | atnd -LF -=DIR -p9   # Display a label (DIR) instead of files. ");
            }
            else
            {
                Console.WriteLine("Atnd -a2 -p567 file        ");
                Console.WriteLine("Atnd -b3 -p567 file        ");
                Console.WriteLine("Atnd -c4 -p567 file        ");
                Console.WriteLine("Atnd -h8 file              ");
                Console.WriteLine("Atnd -h8 < file            ");
                Console.WriteLine("Atnd -i90-123 file         ");
                Console.WriteLine("Atnd -LF -p567 file        ");
                Console.WriteLine("Atnd -LF -p567 -s, file    ");
                Console.WriteLine("Atnd -LF -p567 -s\\x2C file ");
                Console.WriteLine("Atnd -p567 file            ");
                Console.WriteLine("Atnd -V                    ");
                Console.WriteLine("Atnd -VC                   ");
                Console.WriteLine("Atnd file -t9              ");
                Console.WriteLine("DIR | atnd -LF -=DIR -p9   ");
            }

            return ERROR_CODE;
        }

    }
}
