﻿using System;
using System.Configuration;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace Dayu
{
    class CommandPath
    {
        const int FIELD_COUNT = 3000;

        int fieldCount;
        IOException i_o_exception;
        string line;

        private bool openClose(string fileName)
        {
            bool b = true;

            try
            {
                Stream testFile = File.OpenRead(fileName);
                testFile.Close();
            }
            catch (IOException e9)
            {
                b = false;
                i_o_exception = e9;
            }

            return b;
        }

        public CommandPath()
        {
            fieldCount = FIELD_COUNT;
            line = Environment.GetEnvironmentVariable("Path");
        }

        public string errorToString() {
            return i_o_exception.ToString();
        }

        public string pathName(string p)
        {
            const string EMPTY = "";
            string extra = p;
            string fullPath;
            Dividing d = new Dividing(line, ';');
            fieldCount = d.fieldsList(extra, '\\');

            for (int i = 0; i < fieldCount; ++i)
            {
                fullPath = d.field(i);
                if ( openClose(fullPath) )
                {
                    return fullPath;
                }

            }

            return EMPTY;
        }

    }
}
