﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Diyo
{
    class Guide
    {
        const int ERROR_CODE = 1;
        const string EMPTY = "";

        public int versionGuide(double versionNumber, bool comments)
        {
            Console.Write("Diyo C# Version ");
            Console.WriteLine(versionNumber);
            Console.WriteLine(EMPTY);

            if (comments)
            {
            // UTF-8
                Console.WriteLine("Diyo -f bars.txt     # Edit according to bars.txt ");
                Console.WriteLine("Diyo -kﾅ -aN         # ﾅ is subsituted with N. ");
                Console.WriteLine("Diyo -kﾅ -aN file    # ﾅ is subsituted with N to produce a binary file. ");
                Console.WriteLine("Diyo -s① -e１       # ① is subsituted with １ and represented in EUC-JP. ");
                Console.WriteLine("Diyo -s① -e１ file  # ① is subsituted with １ to produce a binary file. ");
                Console.WriteLine("Diyo -s① -e１ -w    # -w shows which table Diyo uses. ");
                Console.WriteLine("Diyo -V              # version ");
                Console.WriteLine("Diyo -VC             # version with comments ");
            }
            else
            {
            // UTF-8
                Console.WriteLine("Diyo -f bars.txt     ");
                Console.WriteLine("Diyo -kﾅ -aN         ");
                Console.WriteLine("Diyo -kﾅ -aN file    ");
                Console.WriteLine("Diyo -s① -e１       ");
                Console.WriteLine("Diyo -s① -e１ file  ");
                Console.WriteLine("Diyo -s① -e１ -w    ");
                Console.WriteLine("Diyo -V              ");
                Console.WriteLine("Diyo -VC             ");
            }

            return ERROR_CODE;
        }

    }
}
