﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Narfi
{
    class Guide
    {
        const int ERROR_CODE = 1;
        const string EMPTY = "";

        public int versionGuide(double versionNumber, bool comments)
        {
            Console.Write("Narfi Version ");
            Console.WriteLine(versionNumber);
            Console.WriteLine(EMPTY);

            if (comments)
            {
                Console.WriteLine("Narfi -b10111 wide             # Read wide to produce Narfi.txt ");
                Console.WriteLine("Narfi -b10111 wide narrow      # Read wide to produce a narrow file. ");
                Console.WriteLine("Narfi -b10111 < wide > narrow  # Read wide to produce a narrow file. ");
                Console.WriteLine("Narfi -c2 wide narrow          # 2 fields ");
                Console.WriteLine("Narfi -c2 -8 wide narrow       # UTF-8 ");
                Console.WriteLine("Narfi -c2 -e wide narrow       # EUC-JP ");
                Console.WriteLine("Narfi -c2 -m wide narrow       # MS932 ");
                Console.WriteLine("Narfi -q wide narrow           # Commas disapper if placed in quotes. ");
                Console.WriteLine("Narfi -s, wide narrow          # CSV ");
                Console.WriteLine("Narfi -s\\l wide narrow         # Wiki table ");
                Console.WriteLine("Narfi -s\\x7C wide narrow       # Wiki table ");
                Console.WriteLine("Narfi -V                       # version ");
                Console.WriteLine("Narfi -VC                      # version with comments ");
            }
            else
            {
                Console.WriteLine("Narfi -b10111 wide             ");
                Console.WriteLine("Narfi -b10111 wide narrow      ");
                Console.WriteLine("Narfi -b10111 < wide > narrow  ");
                Console.WriteLine("Narfi -c2 wide narrow          ");
                Console.WriteLine("Narfi -c2 -8 wide narrow       ");
                Console.WriteLine("Narfi -c2 -e wide narrow       ");
                Console.WriteLine("Narfi -c2 -m wide narrow       ");
                Console.WriteLine("Narfi -q wide narrow           ");
                Console.WriteLine("Narfi -s, wide narrow          ");
                Console.WriteLine("Narfi -s\\l wide narrow         ");
                Console.WriteLine("Narfi -s\\x7C wide narrow       ");
                Console.WriteLine("Narfi -V                       ");
                Console.WriteLine("Narfi -VC                      ");
            }

            return ERROR_CODE;
        }

    }
}
