﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Obot
{
    class Guide
    {
        const int ERROR_CODE = 1;
        const string EMPTY = "";

        public int versionGuide(double versionNumber, bool comments)
        {
            Console.Write("Obot C# Version ");
            Console.WriteLine(versionNumber);
            Console.WriteLine(EMPTY);

            if (comments)
            {
                Console.WriteLine("Obot -b2048 text  # Read 2048 bytes. ");
                Console.WriteLine("Obot -m3 text     # 3 lines can be represented in hexadecimal as 20 0D 0A... ");
                Console.WriteLine("Obot exe          # EXE can be represented in hexadecimal as 4D 5A... ");
                Console.WriteLine("Obot -V           # version ");
                Console.WriteLine("Obot -VC          # version with comments ");
            }
            else
            {
                Console.WriteLine("Obot -b2048 text  ");
                Console.WriteLine("Obot -m3 text     ");
                Console.WriteLine("Obot exe          ");
                Console.WriteLine("Obot -V           ");
                Console.WriteLine("Obot -VC          ");
            }                                               

            return ERROR_CODE;
        }

    }
}
