﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SjisEuc
{
    class Guide
    {
        const int ERROR_CODE = 1;
        const string EMPTY = "";

        public int versionGuide(double versionNumber, bool comments)
        {
            Console.Write("SjisEuc C# Version ");
            Console.WriteLine(versionNumber);
            Console.WriteLine(EMPTY);

            if (comments)
            {
                Console.WriteLine("SjisEuc Shift_JIS.txt                   # Produce SjisEuc.txt ");
                Console.WriteLine("SjisEuc Shift_JIS.txt EUC-JP.txt        # Produce a new file. ");
                Console.WriteLine("SjisEuc Shift_JIS.txt -w                # -w shows which table SjisEuc uses.");
                Console.WriteLine("SjisEuc -CRLF Shift_JIS.txt             # Every line includes 0Dh. ");
                Console.WriteLine("SjisEuc -CRLF Shift_JIS.txt EUC-JP.txt  # Every line includes 0Dh. ");
                Console.WriteLine("SjisEuc < Shift_JIS.txt > EUC-JP.txt    # Every line includes 0Dh. ");
                Console.WriteLine("SjisEuc -LF Shift_JIS.txt               # 0Dh is removed from every line. ");
                Console.WriteLine("SjisEuc -LF Shift_JIS.txt EUC-JP.txt    # 0Dh is removed from every line. ");
                Console.WriteLine("SjisEuc -V                              # version ");
                Console.WriteLine("SjisEuc -VC                             # version with comments ");;
            }
            else
            {
                Console.WriteLine("SjisEuc Shift_JIS.txt                   ");
                Console.WriteLine("SjisEuc Shift_JIS.txt EUC-JP.txt        ");
                Console.WriteLine("SjisEuc Shift_JIS.txt -w                ");
                Console.WriteLine("SjisEuc -CRLF Shift_JIS.txt             ");
                Console.WriteLine("SjisEuc -CRLF Shift_JIS.txt EUC-JP.txt  ");
                Console.WriteLine("SjisEuc < Shift_JIS.txt > EUC-JP.txt    ");
                Console.WriteLine("SjisEuc -LF Shift_JIS.txt               ");
                Console.WriteLine("SjisEuc -LF Shift_JIS.txt EUC-JP.txt    ");
                Console.WriteLine("SjisEuc -V                              ");
                Console.WriteLine("SjisEuc -VC                             ");;
            }

            return ERROR_CODE;
        }

    }
}
