﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Sortk
{
    class Guide
    {
        const int ERROR_CODE = 1;
        const string EMPTY = "";

        public int versionGuide(double versionNumber, bool comments)
        {
            Console.Write("Sortk C# Version ");
            Console.WriteLine(versionNumber);
            Console.WriteLine(EMPTY);

            if (comments)
            {
                Console.WriteLine("Sortk -t, < csv > new    # Read csv to produce a new file. ");
                Console.WriteLine("Sortk -t, -o new csv     # Read csv to produce a new file. ");
                Console.WriteLine("Sortk -t, -j2 csv        # Compare phrases in Field-2. ");
                Console.WriteLine("Sortk -t, -j2 -g csv     # Compare 0.12 with 0.78 in Field-2. ");
                Console.WriteLine("Sortk -t, -j2 -n csv     # Compare 3456 with 9012 in Field-2. ");
                Console.WriteLine("Sortk -t, -k2,2 csv      # Compare phrases in Field-2. ");
                Console.WriteLine("Sortk -t, -k2,3 csv      # Compare phrases from Field-2 to Field-3. ");
                Console.WriteLine("Sortk -t, -k2 csv        # Compare phrases from Field-2 to finish. ");
                Console.WriteLine("Sortk -t, -k2,2 -! csv   # Count ticks. ");
                Console.WriteLine("Sortk -t, -k2,2 -8 csv   # UTF-8 ");
                Console.WriteLine("Sortk -t, -k2,2 -b csv   # Skip 20h in the first part of Field-2. ");
                Console.WriteLine("Sortk -t, -k2,2 -c- csv  # Skip combining characters. ");
                Console.WriteLine("Sortk -t, -k2,2 -e csv   # EUC-JP ");
                Console.WriteLine("Sortk -t, -k2,2 -h csv   # H and I are omitted from ASCII characters. ");
                Console.WriteLine("Sortk -t, -k2,2 -r csv   # Arrange in reverse order. ");
                Console.WriteLine("Sortk -t\\l -k2,2 file    # Wiki table ");
                Console.WriteLine("Sortk -t\\x7C -k2,2 file  # Wiki table ");
                Console.WriteLine("Sortk -V                 # version ");
                Console.WriteLine("Sortk -VC                # version with comments ");
            }
            else
            {
                Console.WriteLine("Sortk -t, < csv > new    ");
                Console.WriteLine("Sortk -t, -o new csv     ");
                Console.WriteLine("Sortk -t, -j2 csv        ");
                Console.WriteLine("Sortk -t, -j2 -g csv     ");
                Console.WriteLine("Sortk -t, -j2 -n csv     ");
                Console.WriteLine("Sortk -t, -k2,2 csv      ");
                Console.WriteLine("Sortk -t, -k2,3 csv      ");
                Console.WriteLine("Sortk -t, -k2 csv        ");
                Console.WriteLine("Sortk -t, -k2,2 -! csv   ");
                Console.WriteLine("Sortk -t, -k2,2 -8 csv   ");
                Console.WriteLine("Sortk -t, -k2,2 -b csv   ");
                Console.WriteLine("Sortk -t, -k2,2 -c- csv  ");
                Console.WriteLine("Sortk -t, -k2,2 -e csv   ");
                Console.WriteLine("Sortk -t, -k2,2 -h csv   ");
                Console.WriteLine("Sortk -t, -k2,2 -r csv   ");
                Console.WriteLine("Sortk -t\\l -k2,2 file    ");
                Console.WriteLine("Sortk -t\\x7C -k2,2 file  ");
                Console.WriteLine("Sortk -V                 ");
                Console.WriteLine("Sortk -VC                ");
           }

            return ERROR_CODE;
        }

    }
}
